#ifndef H_SqlGawk
#define H_SqlGawk

#include "SqlPipe.h"

class SqlGawk : public SqlPipe {
	public :
		HashList *sql_table_hash;
		HashList *sql_field_hash;
		
		Text *sql_tables;
		Text *sql_fields;
		
		char *sql_condition;
		char *sql_action;
		char *sql_expression;
		
		char *sql_path;
		
		int  distinct_flag;
		
		SqlGawk();
		virtual ~SqlGawk( );
		
		Text *sql_triggers;
		
		virtual int	sql();
		virtual int	statement();
		
		virtual int	svalue();
		virtual int	value();
		virtual int	compop();
		virtual int	boolop();
		virtual int	numop();
		virtual int	expression();
		virtual int	condition();
		virtual int	where();
		
		virtual int	begin();
		virtual int	commit();
		virtual int	select();
		virtual int	insert();
		virtual int	del();
		virtual int	update();
		
		virtual int	type();
		virtual int	create();
		virtual int	drop();
		virtual int	load();
		virtual int	unload();
		virtual int	grant();
		virtual int	revoke();
		
		virtual int	sql_gawk(char *cmd,char *file);
		virtual int 	sql_open();
		virtual void	sql_purge();
		virtual char	*sql_lookup_table(char *tname);
		virtual char	*sql_lookup_field(char *fname);
	};

#endif
